import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { EventEmitter, Component, Optional, Inject, ViewChild, Input, Output, NgModule } from '@angular/core';
import * as i3$1 from '@angular/forms';
import { ReactiveFormsModule, NgControl } from '@angular/forms';
import * as i1$1 from '@dynamic-forms/core';
import { DYNAMIC_FORM_THEME, DynamicFormElementModule, DynamicFormButtonBase, DynamicFormActionModule, DynamicFormThemeModule, DynamicFormConfigModule, DynamicFormIconBase, DynamicFormIconModule, DynamicFormAccordionBase, dynamicFormItemsFactory, DynamicFormModalModule, DynamicFormTabsBase, DynamicFormModalBase, dynamicFormModalFactory, DynamicFormInputBase, DynamicFormFileBase, DynamicFormFileModule, DynamicFormTextboxModule, DYNAMIC_FORM_LIBRARY, DYNAMIC_FORM_ID_BUILDER, DynamicFormsModule, DynamicFormControlModule, DynamicFormGroupModule, DynamicFormArrayModule, DynamicFormDictionaryModule, DynamicFormContainerModule, DynamicFormContentModule, DynamicFormTextModule, DynamicFormValidationModule } from '@dynamic-forms/core';
import * as i3 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i1 from '@angular/material/dialog';
import { MatDialogConfig, MatDialogModule } from '@angular/material/dialog';
import * as i4 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i5 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import * as i2$1 from '@angular/material/expansion';
import { MatExpansionModule } from '@angular/material/expansion';
import * as i2$2 from '@angular/material/tabs';
import { MatTabsModule } from '@angular/material/tabs';
import * as i4$3 from '@angular/material/form-field';
import { MatFormFieldModule, MAT_FORM_FIELD_DEFAULT_OPTIONS } from '@angular/material/form-field';
import * as i4$1 from '@angular/material/checkbox';
import { MatCheckboxModule } from '@angular/material/checkbox';
import * as i4$2 from '@angular/material/autocomplete';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import * as i5$1 from '@angular/material/input';
import { MatInputModule, MatInput } from '@angular/material/input';
import { startWith, map } from 'rxjs/operators';
import * as i6 from '@angular/material/core';
import { MatNativeDateModule } from '@angular/material/core';
import * as i6$1 from '@angular/material/datepicker';
import { MatDatepickerModule } from '@angular/material/datepicker';
import * as i4$4 from '@angular/material/radio';
import { MatRadioModule } from '@angular/material/radio';
import * as i5$2 from '@angular/material/select';
import { MatSelectModule } from '@angular/material/select';
import * as i4$5 from '@angular/material/slide-toggle';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import * as i6$2 from '@angular/cdk/text-field';
import * as i4$6 from '@angular/material/button-toggle';
import { MatButtonToggleModule } from '@angular/material/button-toggle';

class MatDynamicFormDialogComponent {
    constructor(dialog, theme) {
        this.dialog = dialog;
        this.theme = theme;
        // eslint-disable-next-line
        this.escaped = new EventEmitter();
    }
    ngOnInit() {
        this._dialogOpenSubscription = this.isOpen$.subscribe(isOpen => isOpen ? this.openDialog() : this.closeDialog());
    }
    ngOnChanges(changes) {
        if (this._dialog && changes.maximized) {
            this._dialog.reference.updateSize(this._dialog.config.width, this._dialog.config.height);
        }
    }
    ngOnDestroy() {
        this._dialogOpenSubscription.unsubscribe();
        this.closeDialog();
    }
    openDialog() {
        this.closeDialog();
        const config = this.getDialogConfig();
        const reference = this.dialog.open(this.dialogTemplateRef, config);
        const subscription = reference.beforeClosed().subscribe(_ => this.escaped.emit());
        this._dialog = { config, reference, subscription };
    }
    closeDialog() {
        if (this._dialog) {
            this._dialog.reference.close();
            this._dialog.subscription.unsubscribe();
            this._dialog = null;
        }
    }
    getDialogConfig() {
        const config = new MatDialogConfig();
        Object.defineProperty(config, 'width', { get: () => this.maximized ? this.maxWidth || '100%' : this.width });
        Object.defineProperty(config, 'height', { get: () => this.maximized ? this.maxHeight || '100%' : this.height });
        Object.defineProperty(config, 'minWidth', { get: () => this.maximized ? this.maxWidth || '100%' : this.minWidth });
        Object.defineProperty(config, 'minHeight', { get: () => this.maximized ? this.maxHeight || '100%' : this.minHeight });
        Object.defineProperty(config, 'maxWidth', { get: () => this.maximized ? this.maxWidth || '100%' : this.maxWidth });
        Object.defineProperty(config, 'maxHeight', { get: () => this.maximized ? this.maxHeight || '100%' : this.maxHeight });
        return config;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormDialogComponent, deps: [{ token: i1.MatDialog }, { token: DYNAMIC_FORM_THEME, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormDialogComponent, selector: "mat-dynamic-form-dialog", inputs: { isOpen$: "isOpen$", children: "children", headerActions: "headerActions", footerActions: "footerActions", width: "width", height: "height", minWidth: "minWidth", minHeight: "minHeight", maxWidth: "maxWidth", maxHeight: "maxHeight", maximized: "maximized", title: "title", titleHtml: "titleHtml", classNameForm: "classNameForm", classNameModal: "classNameModal", classNameChildren: "classNameChildren", classNameHeader: "classNameHeader", classNameFooter: "classNameFooter", classNameTitle: "classNameTitle" }, outputs: { escaped: "escaped" }, viewQueries: [{ propertyName: "dialogTemplateRef", first: true, predicate: ["dialogTemplateRef"], descendants: true, static: true }], usesOnChanges: true, ngImport: i0, template: "<ng-template #dialogTemplateRef>\n  <div class=\"dynamic-form-wrapper\" [ngClass]=\"theme\" [class.maximized]=\"maximized\">\n    <div class=\"dynamic-form\" [ngClass]=\"classNameForm\" [class.maximized]=\"maximized\">\n      <div class=\"dynamic-form-modal\" [ngClass]=\"classNameModal\" [class.maximized]=\"maximized\">\n        <div class=\"modal-header\" *ngIf=\"title || titleHtml || headerActions?.length\" [ngClass]=\"classNameHeader\">\n          <div class=\"modal-title\" *ngIf=\"titleHtml; else titlePlain\" [ngClass]=\"classNameTitle\" [innerHTML]=\"titleHtml\"></div>\n          <ng-template #titlePlain>\n            <div class=\"modal-title\" [ngClass]=\"classNameTitle\">{{ title }}</div>\n          </ng-template>\n          <div class=\"modal-toolbar\" *ngIf=\"headerActions?.length\">\n            <dynamic-form-elements [elements]=\"headerActions\"></dynamic-form-elements>\n          </div>\n        </div>\n        <mat-dialog-content class=\"modal-body\" [ngClass]=\"classNameChildren\" [class.maximized]=\"maximized\">\n          <dynamic-form-elements [elements]=\"children\"></dynamic-form-elements>\n        </mat-dialog-content>\n        <mat-dialog-actions class=\"modal-footer\" *ngIf=\"footerActions?.length\" [ngClass]=\"classNameFooter\">\n          <dynamic-form-elements [elements]=\"footerActions\"></dynamic-form-elements>\n        </mat-dialog-actions>\n      </div>\n    </div>\n  </div>\n</ng-template>\n", dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "directive", type: i1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }, { kind: "component", type: i1$1.DynamicFormElementsComponent, selector: "dynamic-form-elements", inputs: ["elements"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormDialogComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-dialog', template: "<ng-template #dialogTemplateRef>\n  <div class=\"dynamic-form-wrapper\" [ngClass]=\"theme\" [class.maximized]=\"maximized\">\n    <div class=\"dynamic-form\" [ngClass]=\"classNameForm\" [class.maximized]=\"maximized\">\n      <div class=\"dynamic-form-modal\" [ngClass]=\"classNameModal\" [class.maximized]=\"maximized\">\n        <div class=\"modal-header\" *ngIf=\"title || titleHtml || headerActions?.length\" [ngClass]=\"classNameHeader\">\n          <div class=\"modal-title\" *ngIf=\"titleHtml; else titlePlain\" [ngClass]=\"classNameTitle\" [innerHTML]=\"titleHtml\"></div>\n          <ng-template #titlePlain>\n            <div class=\"modal-title\" [ngClass]=\"classNameTitle\">{{ title }}</div>\n          </ng-template>\n          <div class=\"modal-toolbar\" *ngIf=\"headerActions?.length\">\n            <dynamic-form-elements [elements]=\"headerActions\"></dynamic-form-elements>\n          </div>\n        </div>\n        <mat-dialog-content class=\"modal-body\" [ngClass]=\"classNameChildren\" [class.maximized]=\"maximized\">\n          <dynamic-form-elements [elements]=\"children\"></dynamic-form-elements>\n        </mat-dialog-content>\n        <mat-dialog-actions class=\"modal-footer\" *ngIf=\"footerActions?.length\" [ngClass]=\"classNameFooter\">\n          <dynamic-form-elements [elements]=\"footerActions\"></dynamic-form-elements>\n        </mat-dialog-actions>\n      </div>\n    </div>\n  </div>\n</ng-template>\n" }]
        }], ctorParameters: function () { return [{ type: i1.MatDialog }, { type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [DYNAMIC_FORM_THEME]
                }] }]; }, propDecorators: { dialogTemplateRef: [{
                type: ViewChild,
                args: ['dialogTemplateRef', { static: true }]
            }], isOpen$: [{
                type: Input
            }], children: [{
                type: Input
            }], headerActions: [{
                type: Input
            }], footerActions: [{
                type: Input
            }], width: [{
                type: Input
            }], height: [{
                type: Input
            }], minWidth: [{
                type: Input
            }], minHeight: [{
                type: Input
            }], maxWidth: [{
                type: Input
            }], maxHeight: [{
                type: Input
            }], maximized: [{
                type: Input
            }], title: [{
                type: Input
            }], titleHtml: [{
                type: Input
            }], classNameForm: [{
                type: Input
            }], classNameModal: [{
                type: Input
            }], classNameChildren: [{
                type: Input
            }], classNameHeader: [{
                type: Input
            }], classNameFooter: [{
                type: Input
            }], classNameTitle: [{
                type: Input
            }], escaped: [{
                type: Output
            }] } });

class MatDynamicFormDialogModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormDialogModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormDialogModule, declarations: [MatDynamicFormDialogComponent], imports: [CommonModule,
            MatDialogModule,
            DynamicFormElementModule], exports: [MatDynamicFormDialogComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormDialogModule, imports: [CommonModule,
            MatDialogModule,
            DynamicFormElementModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormDialogModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        MatDialogModule,
                        DynamicFormElementModule,
                    ],
                    declarations: [
                        MatDynamicFormDialogComponent,
                    ],
                    exports: [
                        MatDynamicFormDialogComponent,
                    ],
                }]
        }] });

const matDynamicFormLibrary = {
    name: 'material',
    references: ['core'],
};

class MatDynamicFormButtonComponent extends DynamicFormButtonBase {
    constructor(actionService) {
        super(actionService);
        this.actionService = actionService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormButtonComponent, deps: [{ token: i1$1.DynamicFormActionService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormButtonComponent, selector: "mat-dynamic-form-button", usesInheritance: true, ngImport: i0, template: "<button\n  [id]=\"id\"\n  mat-flat-button\n  class=\"dynamic-form-button\"\n  [ngClass]=\"template.className\"\n  [color]=\"template.color | dynamicFormColor : 'primary'\"\n  [type]=\"template.type || 'button'\"\n  [disabled]=\"template.disabled\"\n  [hidden]=\"template.hidden\"\n  (click)=\"onClick($event)\"\n  >{{ template.label }}</button\n>\n\n<mat-dynamic-form-dialog\n  *ngIf=\"dialog\"\n  [isOpen$]=\"dialogOpen$\"\n  [children]=\"dialogChildren\"\n  [headerActions]=\"dialogHeaderActions\"\n  [footerActions]=\"dialogFooterActions\"\n  [width]=\"template.dialogWidth\"\n  [minWidth]=\"template.dialogMinWidth\"\n  [maxWidth]=\"template.dialogMaxWidth\"\n  [title]=\"template.dialogTitle\"\n  [titleHtml]=\"template.dialogTitleHtml\"\n  [classNameForm]=\"element.root.template.className\"\n  [classNameModal]=\"template.className\"\n  [classNameTitle]=\"template.classNameDialogTitle\"\n  [classNameChildren]=\"dialogTemplate?.classNameChildren\"\n  [classNameHeader]=\"dialogTemplate?.classNameHeader\"\n  [classNameFooter]=\"dialogTemplate?.classNameFooter\"\n  (escaped)=\"closeDialog()\"\n></mat-dynamic-form-dialog>\n", dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i3.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "component", type: MatDynamicFormDialogComponent, selector: "mat-dynamic-form-dialog", inputs: ["isOpen$", "children", "headerActions", "footerActions", "width", "height", "minWidth", "minHeight", "maxWidth", "maxHeight", "maximized", "title", "titleHtml", "classNameForm", "classNameModal", "classNameChildren", "classNameHeader", "classNameFooter", "classNameTitle"], outputs: ["escaped"] }, { kind: "pipe", type: i1$1.DynamicFormColorPipe, name: "dynamicFormColor" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-button', template: "<button\n  [id]=\"id\"\n  mat-flat-button\n  class=\"dynamic-form-button\"\n  [ngClass]=\"template.className\"\n  [color]=\"template.color | dynamicFormColor : 'primary'\"\n  [type]=\"template.type || 'button'\"\n  [disabled]=\"template.disabled\"\n  [hidden]=\"template.hidden\"\n  (click)=\"onClick($event)\"\n  >{{ template.label }}</button\n>\n\n<mat-dynamic-form-dialog\n  *ngIf=\"dialog\"\n  [isOpen$]=\"dialogOpen$\"\n  [children]=\"dialogChildren\"\n  [headerActions]=\"dialogHeaderActions\"\n  [footerActions]=\"dialogFooterActions\"\n  [width]=\"template.dialogWidth\"\n  [minWidth]=\"template.dialogMinWidth\"\n  [maxWidth]=\"template.dialogMaxWidth\"\n  [title]=\"template.dialogTitle\"\n  [titleHtml]=\"template.dialogTitleHtml\"\n  [classNameForm]=\"element.root.template.className\"\n  [classNameModal]=\"template.className\"\n  [classNameTitle]=\"template.classNameDialogTitle\"\n  [classNameChildren]=\"dialogTemplate?.classNameChildren\"\n  [classNameHeader]=\"dialogTemplate?.classNameHeader\"\n  [classNameFooter]=\"dialogTemplate?.classNameFooter\"\n  (escaped)=\"closeDialog()\"\n></mat-dynamic-form-dialog>\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.DynamicFormActionService }]; } });

const matDynamicFormButtonType = {
    type: 'button',
    component: MatDynamicFormButtonComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormButtonModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormButtonModule, declarations: [MatDynamicFormButtonComponent], imports: [CommonModule,
            MatButtonModule,
            DynamicFormActionModule,
            DynamicFormThemeModule, i1$1.DynamicFormConfigModule, MatDynamicFormDialogModule], exports: [DynamicFormConfigModule,
            DynamicFormActionModule,
            MatDynamicFormButtonComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormButtonModule, imports: [CommonModule,
            MatButtonModule,
            DynamicFormActionModule,
            DynamicFormThemeModule,
            DynamicFormConfigModule.withAction(matDynamicFormButtonType),
            MatDynamicFormDialogModule, DynamicFormConfigModule,
            DynamicFormActionModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        MatButtonModule,
                        DynamicFormActionModule,
                        DynamicFormThemeModule,
                        DynamicFormConfigModule.withAction(matDynamicFormButtonType),
                        MatDynamicFormDialogModule,
                    ],
                    declarations: [
                        MatDynamicFormButtonComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        DynamicFormActionModule,
                        MatDynamicFormButtonComponent,
                    ],
                }]
        }] });

class MatDynamicFormIconComponent extends DynamicFormIconBase {
    constructor(actionService) {
        super(actionService);
        this.actionService = actionService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormIconComponent, deps: [{ token: i1$1.DynamicFormActionService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormIconComponent, selector: "mat-dynamic-form-icon", usesInheritance: true, ngImport: i0, template: "<div class=\"dynamic-form-icon-wrapper\" [ngClass]=\"template.classNameWrapper\">\n  <button\n    [id]=\"id\"\n    mat-icon-button\n    class=\"dynamic-form-icon\"\n    [ngClass]=\"template.className\"\n    [color]=\"template.color | dynamicFormColor : 'primary'\"\n    [type]=\"template.type || 'button'\"\n    [disabled]=\"template.disabled\"\n    [hidden]=\"template.hidden\"\n    [matTooltip]=\"template.label\"\n    (click)=\"onClick($event)\"\n  >\n    <mat-icon>{{ template.icon | dynamicFormIcon }}</mat-icon>\n  </button>\n</div>\n\n<mat-dynamic-form-dialog\n  *ngIf=\"dialog\"\n  [isOpen$]=\"dialogOpen$\"\n  [children]=\"dialogChildren\"\n  [headerActions]=\"dialogHeaderActions\"\n  [footerActions]=\"dialogFooterActions\"\n  [width]=\"template.dialogWidth\"\n  [minWidth]=\"template.dialogMinWidth\"\n  [maxWidth]=\"template.dialogMaxWidth\"\n  [title]=\"template.dialogTitle\"\n  [titleHtml]=\"template.dialogTitleHtml\"\n  [classNameForm]=\"element.root.template.className\"\n  [classNameModal]=\"template.className\"\n  [classNameTitle]=\"template.classNameDialogTitle\"\n  [classNameChildren]=\"dialogTemplate?.classNameChildren\"\n  [classNameHeader]=\"dialogTemplate?.classNameHeader\"\n  [classNameFooter]=\"dialogTemplate?.classNameFooter\"\n  (escaped)=\"closeDialog()\"\n></mat-dynamic-form-dialog>\n", dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i3.MatIconButton, selector: "button[mat-icon-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "component", type: i4.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "directive", type: i5.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { kind: "component", type: MatDynamicFormDialogComponent, selector: "mat-dynamic-form-dialog", inputs: ["isOpen$", "children", "headerActions", "footerActions", "width", "height", "minWidth", "minHeight", "maxWidth", "maxHeight", "maximized", "title", "titleHtml", "classNameForm", "classNameModal", "classNameChildren", "classNameHeader", "classNameFooter", "classNameTitle"], outputs: ["escaped"] }, { kind: "pipe", type: i1$1.DynamicFormIconPipe, name: "dynamicFormIcon" }, { kind: "pipe", type: i1$1.DynamicFormColorPipe, name: "dynamicFormColor" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormIconComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-icon', template: "<div class=\"dynamic-form-icon-wrapper\" [ngClass]=\"template.classNameWrapper\">\n  <button\n    [id]=\"id\"\n    mat-icon-button\n    class=\"dynamic-form-icon\"\n    [ngClass]=\"template.className\"\n    [color]=\"template.color | dynamicFormColor : 'primary'\"\n    [type]=\"template.type || 'button'\"\n    [disabled]=\"template.disabled\"\n    [hidden]=\"template.hidden\"\n    [matTooltip]=\"template.label\"\n    (click)=\"onClick($event)\"\n  >\n    <mat-icon>{{ template.icon | dynamicFormIcon }}</mat-icon>\n  </button>\n</div>\n\n<mat-dynamic-form-dialog\n  *ngIf=\"dialog\"\n  [isOpen$]=\"dialogOpen$\"\n  [children]=\"dialogChildren\"\n  [headerActions]=\"dialogHeaderActions\"\n  [footerActions]=\"dialogFooterActions\"\n  [width]=\"template.dialogWidth\"\n  [minWidth]=\"template.dialogMinWidth\"\n  [maxWidth]=\"template.dialogMaxWidth\"\n  [title]=\"template.dialogTitle\"\n  [titleHtml]=\"template.dialogTitleHtml\"\n  [classNameForm]=\"element.root.template.className\"\n  [classNameModal]=\"template.className\"\n  [classNameTitle]=\"template.classNameDialogTitle\"\n  [classNameChildren]=\"dialogTemplate?.classNameChildren\"\n  [classNameHeader]=\"dialogTemplate?.classNameHeader\"\n  [classNameFooter]=\"dialogTemplate?.classNameFooter\"\n  (escaped)=\"closeDialog()\"\n></mat-dynamic-form-dialog>\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.DynamicFormActionService }]; } });

const matDynamicFormIconType = {
    type: 'icon',
    component: MatDynamicFormIconComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormIconModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormIconModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormIconModule, declarations: [MatDynamicFormIconComponent], imports: [CommonModule,
            MatButtonModule,
            MatIconModule,
            MatTooltipModule,
            DynamicFormIconModule,
            DynamicFormActionModule,
            DynamicFormThemeModule, i1$1.DynamicFormConfigModule, MatDynamicFormDialogModule], exports: [DynamicFormConfigModule,
            MatDynamicFormIconComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormIconModule, imports: [CommonModule,
            MatButtonModule,
            MatIconModule,
            MatTooltipModule,
            DynamicFormIconModule,
            DynamicFormActionModule,
            DynamicFormThemeModule,
            DynamicFormConfigModule.withAction(matDynamicFormIconType),
            MatDynamicFormDialogModule, DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormIconModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        MatButtonModule,
                        MatIconModule,
                        MatTooltipModule,
                        DynamicFormIconModule,
                        DynamicFormActionModule,
                        DynamicFormThemeModule,
                        DynamicFormConfigModule.withAction(matDynamicFormIconType),
                        MatDynamicFormDialogModule,
                    ],
                    declarations: [
                        MatDynamicFormIconComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormIconComponent,
                    ],
                }]
        }] });

class MatDynamicFormActionModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormActionModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormActionModule, imports: [MatDynamicFormButtonModule,
            MatDynamicFormIconModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormActionModule, imports: [MatDynamicFormButtonModule,
            MatDynamicFormIconModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormActionModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        MatDynamicFormButtonModule,
                        MatDynamicFormIconModule,
                    ],
                }]
        }] });

class MatDynamicFormAccordionComponent extends DynamicFormAccordionBase {
    constructor() {
        super();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormAccordionComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormAccordionComponent, selector: "mat-dynamic-form-accordion", usesInheritance: true, ngImport: i0, template: "<mat-accordion class=\"dynamic-form-items dynamic-form-accordion\" [ngClass]=\"template.className\" [hidden]=\"template.hidden\">\n  <mat-expansion-panel\n    *ngFor=\"let child of element.children; let index = index\"\n    [ngClass]=\"child.template.className\"\n    [expanded]=\"index === selectedIndex\"\n    [disabled]=\"child.disabled\"\n    [hidden]=\"child.template.hidden\"\n    (opened)=\"openItem(index)\"\n    (closed)=\"closeItem(index)\"\n  >\n    <mat-expansion-panel-header class=\"dynamic-form-item-header\">\n      <mat-panel-title>{{ child.label }}</mat-panel-title>\n    </mat-expansion-panel-header>\n    <ng-template matExpansionPanelContent>\n      <div class=\"dynamic-form-item\">\n        <dynamic-form-elements [elements]=\"child.children\"></dynamic-form-elements>\n      </div>\n    </ng-template>\n  </mat-expansion-panel>\n</mat-accordion>\n", dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2$1.MatAccordion, selector: "mat-accordion", inputs: ["multi", "hideToggle", "displayMode", "togglePosition"], exportAs: ["matAccordion"] }, { kind: "component", type: i2$1.MatExpansionPanel, selector: "mat-expansion-panel", inputs: ["disabled", "expanded", "hideToggle", "togglePosition"], outputs: ["opened", "closed", "expandedChange", "afterExpand", "afterCollapse"], exportAs: ["matExpansionPanel"] }, { kind: "component", type: i2$1.MatExpansionPanelHeader, selector: "mat-expansion-panel-header", inputs: ["tabIndex", "expandedHeight", "collapsedHeight"] }, { kind: "directive", type: i2$1.MatExpansionPanelTitle, selector: "mat-panel-title" }, { kind: "directive", type: i2$1.MatExpansionPanelContent, selector: "ng-template[matExpansionPanelContent]" }, { kind: "component", type: i1$1.DynamicFormElementsComponent, selector: "dynamic-form-elements", inputs: ["elements"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormAccordionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-accordion', template: "<mat-accordion class=\"dynamic-form-items dynamic-form-accordion\" [ngClass]=\"template.className\" [hidden]=\"template.hidden\">\n  <mat-expansion-panel\n    *ngFor=\"let child of element.children; let index = index\"\n    [ngClass]=\"child.template.className\"\n    [expanded]=\"index === selectedIndex\"\n    [disabled]=\"child.disabled\"\n    [hidden]=\"child.template.hidden\"\n    (opened)=\"openItem(index)\"\n    (closed)=\"closeItem(index)\"\n  >\n    <mat-expansion-panel-header class=\"dynamic-form-item-header\">\n      <mat-panel-title>{{ child.label }}</mat-panel-title>\n    </mat-expansion-panel-header>\n    <ng-template matExpansionPanelContent>\n      <div class=\"dynamic-form-item\">\n        <dynamic-form-elements [elements]=\"child.children\"></dynamic-form-elements>\n      </div>\n    </ng-template>\n  </mat-expansion-panel>\n</mat-accordion>\n" }]
        }], ctorParameters: function () { return []; } });

const matDynamicFormAccordionType = {
    type: 'accordion',
    factory: dynamicFormItemsFactory,
    component: MatDynamicFormAccordionComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormAccordionModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormAccordionModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormAccordionModule, declarations: [MatDynamicFormAccordionComponent], imports: [CommonModule,
            MatExpansionModule,
            DynamicFormElementModule,
            DynamicFormModalModule, i1$1.DynamicFormConfigModule], exports: [DynamicFormConfigModule,
            MatDynamicFormAccordionComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormAccordionModule, imports: [CommonModule,
            MatExpansionModule,
            DynamicFormElementModule,
            DynamicFormModalModule,
            DynamicFormConfigModule.withElement(matDynamicFormAccordionType), DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormAccordionModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        MatExpansionModule,
                        DynamicFormElementModule,
                        DynamicFormModalModule,
                        DynamicFormConfigModule.withElement(matDynamicFormAccordionType),
                    ],
                    declarations: [
                        MatDynamicFormAccordionComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormAccordionComponent,
                    ],
                }]
        }] });

class MatDynamicFormTabsComponent extends DynamicFormTabsBase {
    constructor() {
        super();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTabsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormTabsComponent, selector: "mat-dynamic-form-tabs", usesInheritance: true, ngImport: i0, template: "<mat-tab-group\n  class=\"dynamic-form-items dynamic-form-tabs\"\n  [ngClass]=\"template.className\"\n  [hidden]=\"template.hidden\"\n  [selectedIndex]=\"selectedIndex\"\n  (selectedIndexChange)=\"selectItem($event)\"\n>\n  <mat-tab\n    *ngFor=\"let child of element.children\"\n    [ngClass]=\"child.template.className\"\n    [disabled]=\"child.disabled\"\n    [hidden]=\"template.hidden\"\n  >\n    <ng-template matTabLabel>\n      <div class=\"dynamic-form-item-header\">{{ child.label }}</div>\n    </ng-template>\n    <ng-template matTabContent>\n      <div class=\"dynamic-form-item\">\n        <dynamic-form-elements [elements]=\"child.children\"></dynamic-form-elements>\n      </div>\n    </ng-template>\n  </mat-tab>\n</mat-tab-group>\n", dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2$2.MatTabContent, selector: "[matTabContent]" }, { kind: "directive", type: i2$2.MatTabLabel, selector: "[mat-tab-label], [matTabLabel]" }, { kind: "component", type: i2$2.MatTab, selector: "mat-tab", inputs: ["disabled"], exportAs: ["matTab"] }, { kind: "component", type: i2$2.MatTabGroup, selector: "mat-tab-group", inputs: ["color", "disableRipple", "fitInkBarToContent", "mat-stretch-tabs"], exportAs: ["matTabGroup"] }, { kind: "component", type: i1$1.DynamicFormElementsComponent, selector: "dynamic-form-elements", inputs: ["elements"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTabsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-tabs', template: "<mat-tab-group\n  class=\"dynamic-form-items dynamic-form-tabs\"\n  [ngClass]=\"template.className\"\n  [hidden]=\"template.hidden\"\n  [selectedIndex]=\"selectedIndex\"\n  (selectedIndexChange)=\"selectItem($event)\"\n>\n  <mat-tab\n    *ngFor=\"let child of element.children\"\n    [ngClass]=\"child.template.className\"\n    [disabled]=\"child.disabled\"\n    [hidden]=\"template.hidden\"\n  >\n    <ng-template matTabLabel>\n      <div class=\"dynamic-form-item-header\">{{ child.label }}</div>\n    </ng-template>\n    <ng-template matTabContent>\n      <div class=\"dynamic-form-item\">\n        <dynamic-form-elements [elements]=\"child.children\"></dynamic-form-elements>\n      </div>\n    </ng-template>\n  </mat-tab>\n</mat-tab-group>\n" }]
        }], ctorParameters: function () { return []; } });

const matDynamicFormTabsType = {
    type: 'tabs',
    factory: dynamicFormItemsFactory,
    component: MatDynamicFormTabsComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormTabsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTabsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTabsModule, declarations: [MatDynamicFormTabsComponent], imports: [CommonModule,
            MatTabsModule,
            DynamicFormElementModule,
            DynamicFormModalModule, i1$1.DynamicFormConfigModule], exports: [DynamicFormConfigModule,
            MatDynamicFormTabsComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTabsModule, imports: [CommonModule,
            MatTabsModule,
            DynamicFormElementModule,
            DynamicFormModalModule,
            DynamicFormConfigModule.withElement(matDynamicFormTabsType), DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTabsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        MatTabsModule,
                        DynamicFormElementModule,
                        DynamicFormModalModule,
                        DynamicFormConfigModule.withElement(matDynamicFormTabsType),
                    ],
                    declarations: [
                        MatDynamicFormTabsComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormTabsComponent,
                    ],
                }]
        }] });

class MatDynamicFormItemsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormItemsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormItemsModule, imports: [MatDynamicFormAccordionModule,
            MatDynamicFormTabsModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormItemsModule, imports: [MatDynamicFormAccordionModule,
            MatDynamicFormTabsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormItemsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        MatDynamicFormAccordionModule,
                        MatDynamicFormTabsModule,
                    ],
                }]
        }] });

class MatDynamicFormModalComponent extends DynamicFormModalBase {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormModalComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormModalComponent, selector: "mat-dynamic-form-modal", usesInheritance: true, ngImport: i0, template: "<dynamic-form-element *ngIf=\"trigger\" [element]=\"trigger\"></dynamic-form-element>\n\n<mat-dynamic-form-dialog\n  [isOpen$]=\"isOpen$\"\n  [children]=\"children\"\n  [headerActions]=\"headerActions\"\n  [footerActions]=\"footerActions\"\n  [width]=\"template.width\"\n  [height]=\"template.height\"\n  [minWidth]=\"template.minWidth\"\n  [minHeight]=\"template.minHeight\"\n  [maxWidth]=\"template.maxWidth\"\n  [maxHeight]=\"template.maxHeight\"\n  [maximized]=\"template.maximized\"\n  [title]=\"template.title\"\n  [titleHtml]=\"template.titleHtml\"\n  [classNameForm]=\"element.root.template.className\"\n  [classNameModal]=\"template.className\"\n  [classNameTitle]=\"template.classNameTitle\"\n  [classNameChildren]=\"template.classNameChildren\"\n  [classNameHeader]=\"template.classNameHeader\"\n  [classNameFooter]=\"template.classNameFooter\"\n  (escaped)=\"element.close()\"\n></mat-dynamic-form-dialog>\n", dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1$1.DynamicFormElementComponent, selector: "dynamic-form-element" }, { kind: "component", type: MatDynamicFormDialogComponent, selector: "mat-dynamic-form-dialog", inputs: ["isOpen$", "children", "headerActions", "footerActions", "width", "height", "minWidth", "minHeight", "maxWidth", "maxHeight", "maximized", "title", "titleHtml", "classNameForm", "classNameModal", "classNameChildren", "classNameHeader", "classNameFooter", "classNameTitle"], outputs: ["escaped"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormModalComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-modal', template: "<dynamic-form-element *ngIf=\"trigger\" [element]=\"trigger\"></dynamic-form-element>\n\n<mat-dynamic-form-dialog\n  [isOpen$]=\"isOpen$\"\n  [children]=\"children\"\n  [headerActions]=\"headerActions\"\n  [footerActions]=\"footerActions\"\n  [width]=\"template.width\"\n  [height]=\"template.height\"\n  [minWidth]=\"template.minWidth\"\n  [minHeight]=\"template.minHeight\"\n  [maxWidth]=\"template.maxWidth\"\n  [maxHeight]=\"template.maxHeight\"\n  [maximized]=\"template.maximized\"\n  [title]=\"template.title\"\n  [titleHtml]=\"template.titleHtml\"\n  [classNameForm]=\"element.root.template.className\"\n  [classNameModal]=\"template.className\"\n  [classNameTitle]=\"template.classNameTitle\"\n  [classNameChildren]=\"template.classNameChildren\"\n  [classNameHeader]=\"template.classNameHeader\"\n  [classNameFooter]=\"template.classNameFooter\"\n  (escaped)=\"element.close()\"\n></mat-dynamic-form-dialog>\n" }]
        }] });

const matDynamicFormModalType = {
    type: 'modal',
    factory: dynamicFormModalFactory,
    component: MatDynamicFormModalComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormModalModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormModalModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormModalModule, declarations: [MatDynamicFormModalComponent], imports: [CommonModule,
            DynamicFormElementModule,
            DynamicFormModalModule, i1$1.DynamicFormConfigModule, MatDynamicFormDialogModule], exports: [DynamicFormConfigModule,
            MatDynamicFormModalComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormModalModule, imports: [CommonModule,
            DynamicFormElementModule,
            DynamicFormModalModule,
            DynamicFormConfigModule.withElement(matDynamicFormModalType),
            MatDynamicFormDialogModule, DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormModalModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        DynamicFormElementModule,
                        DynamicFormModalModule,
                        DynamicFormConfigModule.withElement(matDynamicFormModalType),
                        MatDynamicFormDialogModule,
                    ],
                    declarations: [
                        MatDynamicFormModalComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormModalComponent,
                    ],
                }]
        }] });

class MatDynamicFormElementModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormElementModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormElementModule, imports: [MatDynamicFormItemsModule,
            MatDynamicFormModalModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormElementModule, imports: [MatDynamicFormItemsModule,
            MatDynamicFormModalModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormElementModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        MatDynamicFormItemsModule,
                        MatDynamicFormModalModule,
                    ],
                }]
        }] });

class MatDynamicFormInputWrapperComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormInputWrapperComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormInputWrapperComponent, selector: "mat-dynamic-form-input-wrapper", inputs: { label: "label", required: "required", invalid: "invalid", errorMessage: "errorMessage" }, ngImport: i0, template: "<div class=\"mat-mdc-form-field mat-mdc-form-field-wrapper\" [ngClass]=\"{ 'mdc-text-field--invalid': invalid }\">\n  <div class=\"mat-mdc-form-field-input-wrapper\">\n    <label *ngIf=\"label\" class=\"mat-mdc-form-field-input-label mat-mdc-floating-label mdc-floating-label\"\n      >{{ label }}<span *ngIf=\"required\">*</span></label\n    >\n    <ng-content></ng-content>\n  </div>\n  <div class=\"mat-mdc-form-field-subscript-wrapper mat-mdc-form-field-bottom-align\">\n    <div *ngIf=\"invalid\" class=\"mat-mdc-form-field-error-wrapper\">\n      <div class=\"mat-mdc-form-field-error mat-mdc-form-field-bottom-align\">{{ errorMessage }}</div>\n    </div>\n  </div>\n</div>\n", dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormInputWrapperComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-input-wrapper', template: "<div class=\"mat-mdc-form-field mat-mdc-form-field-wrapper\" [ngClass]=\"{ 'mdc-text-field--invalid': invalid }\">\n  <div class=\"mat-mdc-form-field-input-wrapper\">\n    <label *ngIf=\"label\" class=\"mat-mdc-form-field-input-label mat-mdc-floating-label mdc-floating-label\"\n      >{{ label }}<span *ngIf=\"required\">*</span></label\n    >\n    <ng-content></ng-content>\n  </div>\n  <div class=\"mat-mdc-form-field-subscript-wrapper mat-mdc-form-field-bottom-align\">\n    <div *ngIf=\"invalid\" class=\"mat-mdc-form-field-error-wrapper\">\n      <div class=\"mat-mdc-form-field-error mat-mdc-form-field-bottom-align\">{{ errorMessage }}</div>\n    </div>\n  </div>\n</div>\n" }]
        }], propDecorators: { label: [{
                type: Input
            }], required: [{
                type: Input
            }], invalid: [{
                type: Input
            }], errorMessage: [{
                type: Input
            }] } });

class MatDynamicFormInputWrapperModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormInputWrapperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormInputWrapperModule, declarations: [MatDynamicFormInputWrapperComponent], imports: [CommonModule], exports: [MatDynamicFormInputWrapperComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormInputWrapperModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormInputWrapperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                    ],
                    declarations: [
                        MatDynamicFormInputWrapperComponent,
                    ],
                    exports: [
                        MatDynamicFormInputWrapperComponent,
                    ],
                }]
        }] });

class MatDynamicFormCheckboxComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormCheckboxComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormCheckboxComponent, selector: "mat-dynamic-form-checkbox", usesInheritance: true, ngImport: i0, template: "<mat-dynamic-form-input-wrapper [invalid]=\"showErrors\" [errorMessage]=\"showErrors ? errorMessage : null\">\n  <mat-checkbox\n    [id]=\"inputId\"\n    color=\"primary\"\n    [indeterminate]=\"input?.indeterminate\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n    >{{ template.label }}<span *ngIf=\"validation?.required\">*</span></mat-checkbox\n  >\n</mat-dynamic-form-input-wrapper>\n", dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i3$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: i4$1.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex"], exportAs: ["matCheckbox"] }, { kind: "directive", type: i4$1.MatCheckboxRequiredValidator, selector: "mat-checkbox[required][formControlName],             mat-checkbox[required][formControl], mat-checkbox[required][ngModel]" }, { kind: "component", type: MatDynamicFormInputWrapperComponent, selector: "mat-dynamic-form-input-wrapper", inputs: ["label", "required", "invalid", "errorMessage"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormCheckboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-checkbox', template: "<mat-dynamic-form-input-wrapper [invalid]=\"showErrors\" [errorMessage]=\"showErrors ? errorMessage : null\">\n  <mat-checkbox\n    [id]=\"inputId\"\n    color=\"primary\"\n    [indeterminate]=\"input?.indeterminate\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n    >{{ template.label }}<span *ngIf=\"validation?.required\">*</span></mat-checkbox\n  >\n</mat-dynamic-form-input-wrapper>\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.DynamicFormValidationService }]; } });

const matDynamicFormCheckboxType = {
    type: 'checkbox',
    component: MatDynamicFormCheckboxComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormCheckboxModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormCheckboxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormCheckboxModule, declarations: [MatDynamicFormCheckboxComponent], imports: [CommonModule,
            ReactiveFormsModule,
            MatCheckboxModule,
            MatDynamicFormInputWrapperModule, i1$1.DynamicFormConfigModule], exports: [DynamicFormConfigModule,
            MatDynamicFormCheckboxComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormCheckboxModule, imports: [CommonModule,
            ReactiveFormsModule,
            MatCheckboxModule,
            MatDynamicFormInputWrapperModule,
            DynamicFormConfigModule.withInput(matDynamicFormCheckboxType), DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormCheckboxModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        MatCheckboxModule,
                        MatDynamicFormInputWrapperModule,
                        DynamicFormConfigModule.withInput(matDynamicFormCheckboxType),
                    ],
                    declarations: [
                        MatDynamicFormCheckboxComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormCheckboxComponent,
                    ],
                }]
        }] });

class MatDynamicFormComboboxComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    ngOnInit() {
        this.filteredOptions = this.control.valueChanges.pipe(startWith(''), map(value => this.getFilteredOptions(value)));
    }
    getFilteredOptions(value) {
        const valueNormalized = value ? value.toUpperCase() : null;
        return valueNormalized
            ? this.input.options?.filter(option => option.toUpperCase().includes(valueNormalized))
            : this.input.options;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormComboboxComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormComboboxComponent, selector: "mat-dynamic-form-combobox", usesInheritance: true, ngImport: i0, template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    [id]=\"inputId\"\n    type=\"text\"\n    [placeholder]=\"input.placeholder\"\n    [matAutocomplete]=\"auto\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <mat-autocomplete #auto=\"matAutocomplete\">\n    <mat-option *ngFor=\"let option of filteredOptions | async\" [value]=\"option\">{{ option }}</mat-option>\n  </mat-autocomplete>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matTextPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matTextSuffix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matSuffix\n  ></dynamic-form-element>\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n", dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i3$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: i4$2.MatAutocomplete, selector: "mat-autocomplete", inputs: ["disableRipple", "hideSingleSelectionIndicator"], exportAs: ["matAutocomplete"] }, { kind: "component", type: i6.MatOption, selector: "mat-option", exportAs: ["matOption"] }, { kind: "directive", type: i4$2.MatAutocompleteTrigger, selector: "input[matAutocomplete], textarea[matAutocomplete]", exportAs: ["matAutocompleteTrigger"] }, { kind: "component", type: i4$3.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4$3.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4$3.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i4$3.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i4$3.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i4$3.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "directive", type: i5$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i1$1.DynamicFormElementComponent, selector: "dynamic-form-element" }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormComboboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-combobox', template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    [id]=\"inputId\"\n    type=\"text\"\n    [placeholder]=\"input.placeholder\"\n    [matAutocomplete]=\"auto\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <mat-autocomplete #auto=\"matAutocomplete\">\n    <mat-option *ngFor=\"let option of filteredOptions | async\" [value]=\"option\">{{ option }}</mat-option>\n  </mat-autocomplete>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matTextPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matTextSuffix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matSuffix\n  ></dynamic-form-element>\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.DynamicFormValidationService }]; } });

const matDynamicFormComboboxType = {
    type: 'combobox',
    component: MatDynamicFormComboboxComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormComboboxModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormComboboxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormComboboxModule, declarations: [MatDynamicFormComboboxComponent], imports: [CommonModule,
            ReactiveFormsModule,
            MatAutocompleteModule,
            MatFormFieldModule,
            MatInputModule,
            DynamicFormElementModule, i1$1.DynamicFormConfigModule], exports: [DynamicFormConfigModule,
            MatDynamicFormComboboxComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormComboboxModule, imports: [CommonModule,
            ReactiveFormsModule,
            MatAutocompleteModule,
            MatFormFieldModule,
            MatInputModule,
            DynamicFormElementModule,
            DynamicFormConfigModule.withInput(matDynamicFormComboboxType), DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormComboboxModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        MatAutocompleteModule,
                        MatFormFieldModule,
                        MatInputModule,
                        DynamicFormElementModule,
                        DynamicFormConfigModule.withInput(matDynamicFormComboboxType),
                    ],
                    declarations: [
                        MatDynamicFormComboboxComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormComboboxComponent,
                    ],
                }]
        }] });

class MatDynamicFormDatepickerComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormDatepickerComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormDatepickerComponent, selector: "mat-dynamic-form-datepicker", usesInheritance: true, ngImport: i0, template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\" [class.suffixes-flex]=\"suffixAddOn\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [matDatepicker]=\"datepicker\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <mat-datepicker-toggle matSuffix [for]=\"datepicker\" [disabled]=\"control.disabled || readonly\"></mat-datepicker-toggle>\n  <mat-datepicker #datepicker [disabled]=\"control.disabled\"></mat-datepicker>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matTextPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matTextSuffix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matSuffix\n  ></dynamic-form-element>\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n", dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i3$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: i5$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i4$3.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4$3.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4$3.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i4$3.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i4$3.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i4$3.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "component", type: i6$1.MatDatepicker, selector: "mat-datepicker", exportAs: ["matDatepicker"] }, { kind: "directive", type: i6$1.MatDatepickerInput, selector: "input[matDatepicker]", inputs: ["matDatepicker", "min", "max", "matDatepickerFilter"], exportAs: ["matDatepickerInput"] }, { kind: "component", type: i6$1.MatDatepickerToggle, selector: "mat-datepicker-toggle", inputs: ["for", "tabIndex", "aria-label", "disabled", "disableRipple"], exportAs: ["matDatepickerToggle"] }, { kind: "component", type: i1$1.DynamicFormElementComponent, selector: "dynamic-form-element" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormDatepickerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-datepicker', template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\" [class.suffixes-flex]=\"suffixAddOn\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [matDatepicker]=\"datepicker\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <mat-datepicker-toggle matSuffix [for]=\"datepicker\" [disabled]=\"control.disabled || readonly\"></mat-datepicker-toggle>\n  <mat-datepicker #datepicker [disabled]=\"control.disabled\"></mat-datepicker>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matTextPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matTextSuffix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matSuffix\n  ></dynamic-form-element>\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.DynamicFormValidationService }]; } });

const matDynamicFormDatepickerType = {
    type: 'datepicker',
    component: MatDynamicFormDatepickerComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormDatepickerModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormDatepickerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormDatepickerModule, declarations: [MatDynamicFormDatepickerComponent], imports: [CommonModule,
            ReactiveFormsModule,
            MatInputModule,
            MatFormFieldModule,
            MatDatepickerModule,
            MatNativeDateModule,
            DynamicFormElementModule, i1$1.DynamicFormConfigModule], exports: [DynamicFormConfigModule,
            MatDynamicFormDatepickerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormDatepickerModule, imports: [CommonModule,
            ReactiveFormsModule,
            MatInputModule,
            MatFormFieldModule,
            MatDatepickerModule,
            MatNativeDateModule,
            DynamicFormElementModule,
            DynamicFormConfigModule.withInput(matDynamicFormDatepickerType), DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormDatepickerModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        MatInputModule,
                        MatFormFieldModule,
                        MatDatepickerModule,
                        MatNativeDateModule,
                        DynamicFormElementModule,
                        DynamicFormConfigModule.withInput(matDynamicFormDatepickerType),
                    ],
                    declarations: [
                        MatDynamicFormDatepickerComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormDatepickerComponent,
                    ],
                }]
        }] });

class MatDynamicFormFileComponent extends DynamicFormFileBase {
    constructor(builder, validationService) {
        super(builder, validationService);
        this.builder = builder;
        this.validationService = validationService;
    }
    ngOnInit() {
        super.ngOnInit();
        Object.defineProperty(this._matInput, 'ngControl', { get: () => this._ngControl });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormFileComponent, deps: [{ token: i1$1.DynamicFormBuilder }, { token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormFileComponent, selector: "mat-dynamic-form-file", viewQueries: [{ propertyName: "_matInput", first: true, predicate: MatInput, descendants: true, static: true }, { propertyName: "_ngControl", first: true, predicate: NgControl, descendants: true, static: true }], usesInheritance: true, ngImport: i0, template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\" [class.suffixes-flex]=\"suffixAddOn\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [value]=\"fileDirective.fileNamesAsText || ''\"\n    [disabled]=\"control.disabled\"\n    (blur)=\"control.markAsTouched()\"\n    readonly\n  />\n  <input\n    fileControl\n    #fileDirective=\"dynamicFormFile\"\n    dynamicFormFile\n    [acceptFiles]=\"input.accept\"\n    [multipleFiles]=\"input.multiple\"\n    [formControl]=\"control\"\n  />\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matTextPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element [element]=\"uploadAction\" matSuffix></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matTextSuffix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matSuffix\n  ></dynamic-form-element>\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n", dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: i5$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i4$3.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4$3.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4$3.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i4$3.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i4$3.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i4$3.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "directive", type: i1$1.DynamicFormFileDirective, selector: "[dynamicFormFile]", inputs: ["acceptFiles", "multipleFiles"], exportAs: ["dynamicFormFile"] }, { kind: "component", type: i1$1.DynamicFormElementComponent, selector: "dynamic-form-element" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormFileComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-file', template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\" [class.suffixes-flex]=\"suffixAddOn\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [value]=\"fileDirective.fileNamesAsText || ''\"\n    [disabled]=\"control.disabled\"\n    (blur)=\"control.markAsTouched()\"\n    readonly\n  />\n  <input\n    fileControl\n    #fileDirective=\"dynamicFormFile\"\n    dynamicFormFile\n    [acceptFiles]=\"input.accept\"\n    [multipleFiles]=\"input.multiple\"\n    [formControl]=\"control\"\n  />\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matTextPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element [element]=\"uploadAction\" matSuffix></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matTextSuffix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matSuffix\n  ></dynamic-form-element>\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.DynamicFormBuilder }, { type: i1$1.DynamicFormValidationService }]; }, propDecorators: { _matInput: [{
                type: ViewChild,
                args: [MatInput, { static: true }]
            }], _ngControl: [{
                type: ViewChild,
                args: [NgControl, { static: true }]
            }] } });

const matDynamicFormFileType = {
    type: 'file',
    component: MatDynamicFormFileComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormFileModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormFileModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormFileModule, declarations: [MatDynamicFormFileComponent], imports: [CommonModule,
            ReactiveFormsModule,
            MatInputModule,
            MatFormFieldModule,
            DynamicFormFileModule,
            DynamicFormElementModule, i1$1.DynamicFormConfigModule], exports: [DynamicFormConfigModule,
            MatDynamicFormFileComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormFileModule, imports: [CommonModule,
            ReactiveFormsModule,
            MatInputModule,
            MatFormFieldModule,
            DynamicFormFileModule,
            DynamicFormElementModule,
            DynamicFormConfigModule.withInput(matDynamicFormFileType), DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormFileModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        MatInputModule,
                        MatFormFieldModule,
                        DynamicFormFileModule,
                        DynamicFormElementModule,
                        DynamicFormConfigModule.withInput(matDynamicFormFileType),
                    ],
                    declarations: [
                        MatDynamicFormFileComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormFileComponent,
                    ],
                }]
        }] });

class MatDynamicFormNumberboxComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormNumberboxComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormNumberboxComponent, selector: "mat-dynamic-form-numberbox", usesInheritance: true, ngImport: i0, template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    [id]=\"inputId\"\n    type=\"number\"\n    [placeholder]=\"input.placeholder\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matTextPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matTextSuffix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matSuffix\n  ></dynamic-form-element>\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n", dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3$1.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i3$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i3$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: i4$3.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4$3.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4$3.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i4$3.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i4$3.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i4$3.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "directive", type: i5$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i1$1.DynamicFormElementComponent, selector: "dynamic-form-element" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormNumberboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-numberbox', template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    [id]=\"inputId\"\n    type=\"number\"\n    [placeholder]=\"input.placeholder\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matTextPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matTextSuffix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matSuffix\n  ></dynamic-form-element>\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.DynamicFormValidationService }]; } });

const matDynamicFormNumberboxType = {
    type: 'numberbox',
    component: MatDynamicFormNumberboxComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormNumberboxModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormNumberboxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormNumberboxModule, declarations: [MatDynamicFormNumberboxComponent], imports: [CommonModule,
            ReactiveFormsModule,
            MatFormFieldModule,
            MatInputModule,
            DynamicFormElementModule, i1$1.DynamicFormConfigModule], exports: [DynamicFormConfigModule,
            MatDynamicFormNumberboxComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormNumberboxModule, imports: [CommonModule,
            ReactiveFormsModule,
            MatFormFieldModule,
            MatInputModule,
            DynamicFormElementModule,
            DynamicFormConfigModule.withInput(matDynamicFormNumberboxType), DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormNumberboxModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        MatFormFieldModule,
                        MatInputModule,
                        DynamicFormElementModule,
                        DynamicFormConfigModule.withInput(matDynamicFormNumberboxType),
                    ],
                    declarations: [
                        MatDynamicFormNumberboxComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormNumberboxComponent,
                    ],
                }]
        }] });

class MatDynamicFormRadioComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormRadioComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormRadioComponent, selector: "mat-dynamic-form-radio", usesInheritance: true, ngImport: i0, template: "<mat-dynamic-form-input-wrapper\n  [label]=\"template.label\"\n  [required]=\"validation?.required\"\n  [invalid]=\"showErrors\"\n  [errorMessage]=\"showErrors ? errorMessage : null\"\n>\n  <mat-radio-group [formControl]=\"control\">\n    <ng-container *ngFor=\"let option of input.options; let i = index\">\n      <mat-radio-button [id]=\"inputId + '-' + i\" color=\"primary\" [value]=\"option.value\" [disabled]=\"option.disabled\">{{\n        option.label\n      }}</mat-radio-button>\n    </ng-container>\n  </mat-radio-group>\n</mat-dynamic-form-input-wrapper>\n", dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i3$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: i4$4.MatRadioGroup, selector: "mat-radio-group", exportAs: ["matRadioGroup"] }, { kind: "component", type: i4$4.MatRadioButton, selector: "mat-radio-button", inputs: ["disableRipple", "tabIndex"], exportAs: ["matRadioButton"] }, { kind: "component", type: MatDynamicFormInputWrapperComponent, selector: "mat-dynamic-form-input-wrapper", inputs: ["label", "required", "invalid", "errorMessage"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormRadioComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-radio', template: "<mat-dynamic-form-input-wrapper\n  [label]=\"template.label\"\n  [required]=\"validation?.required\"\n  [invalid]=\"showErrors\"\n  [errorMessage]=\"showErrors ? errorMessage : null\"\n>\n  <mat-radio-group [formControl]=\"control\">\n    <ng-container *ngFor=\"let option of input.options; let i = index\">\n      <mat-radio-button [id]=\"inputId + '-' + i\" color=\"primary\" [value]=\"option.value\" [disabled]=\"option.disabled\">{{\n        option.label\n      }}</mat-radio-button>\n    </ng-container>\n  </mat-radio-group>\n</mat-dynamic-form-input-wrapper>\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.DynamicFormValidationService }]; } });

const matDynamicFormRadioType = {
    type: 'radio',
    component: MatDynamicFormRadioComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormRadioModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormRadioModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormRadioModule, declarations: [MatDynamicFormRadioComponent], imports: [CommonModule,
            ReactiveFormsModule,
            MatRadioModule,
            MatDynamicFormInputWrapperModule, i1$1.DynamicFormConfigModule], exports: [DynamicFormConfigModule,
            MatDynamicFormRadioComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormRadioModule, imports: [CommonModule,
            ReactiveFormsModule,
            MatRadioModule,
            MatDynamicFormInputWrapperModule,
            DynamicFormConfigModule.withInput(matDynamicFormRadioType), DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormRadioModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        MatRadioModule,
                        MatDynamicFormInputWrapperModule,
                        DynamicFormConfigModule.withInput(matDynamicFormRadioType),
                    ],
                    declarations: [
                        MatDynamicFormRadioComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormRadioComponent,
                    ],
                }]
        }] });

class MatDynamicFormSelectComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormSelectComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormSelectComponent, selector: "mat-dynamic-form-select", usesInheritance: true, ngImport: i0, template: "<mat-form-field *ngIf=\"!input.multiple; else multiSelect\" appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <mat-select [id]=\"inputId\" [placeholder]=\"input.placeholder\" [required]=\"validation?.required\" [formControl]=\"control\">\n    <ng-container *ngFor=\"let option of input.options\">\n      <ng-container *ngIf=\"!option.items; else optionGroup\">\n        <mat-option [value]=\"option.value\" [disabled]=\"option.disabled\">{{ option.label }}</mat-option>\n      </ng-container>\n      <ng-template #optionGroup>\n        <mat-optgroup [label]=\"option.label\" [disabled]=\"option.disabled\">\n          <ng-container *ngFor=\"let optionItem of option.items\">\n            <mat-option [value]=\"optionItem.value\" [disabled]=\"optionItem.disabled\">{{ optionItem.label }}</mat-option>\n          </ng-container>\n        </mat-optgroup>\n      </ng-template>\n    </ng-container>\n  </mat-select>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matTextPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matTextSuffix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matSuffix\n  ></dynamic-form-element>\n  <mat-hint [align]=\"'start'\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint [align]=\"'end'\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n<ng-template #multiSelect>\n  <mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n    <mat-label>{{ template.label }}</mat-label>\n    <mat-select [id]=\"inputId\" [placeholder]=\"input.placeholder\" [required]=\"validation?.required\" [formControl]=\"control\" multiple>\n      <ng-container *ngFor=\"let option of input.options\">\n        <ng-container *ngIf=\"!option.items; else optionGroup\">\n          <mat-option [value]=\"option.value\" [disabled]=\"option.disabled\">{{ option.label }}</mat-option>\n        </ng-container>\n        <ng-template #optionGroup>\n          <mat-optgroup [label]=\"option.label\" [disabled]=\"option.disabled\">\n            <ng-container *ngFor=\"let optionItem of option.items\">\n              <mat-option [value]=\"optionItem.value\" [disabled]=\"optionItem.disabled\">{{ optionItem.label }}</mat-option>\n            </ng-container>\n          </mat-optgroup>\n        </ng-template>\n      </ng-container>\n    </mat-select>\n    <dynamic-form-element\n      *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n      [element]=\"prefixAddOn\"\n      matTextPrefix\n    ></dynamic-form-element>\n    <dynamic-form-element\n      *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n      [element]=\"prefixAddOn\"\n      matPrefix\n    ></dynamic-form-element>\n    <dynamic-form-element\n      *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n      [element]=\"suffixAddOn\"\n      matTextSuffix\n    ></dynamic-form-element>\n    <dynamic-form-element\n      *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n      [element]=\"suffixAddOn\"\n      matSuffix\n    ></dynamic-form-element>\n    <mat-hint [align]=\"'start'\">{{ hints?.hintStart }}</mat-hint>\n    <mat-hint [align]=\"'end'\">{{ hints?.hintEnd }}</mat-hint>\n    <mat-error>{{ errorMessage }}</mat-error>\n  </mat-form-field>\n</ng-template>\n", dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i3$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: i4$3.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4$3.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4$3.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i4$3.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i4$3.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i4$3.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "component", type: i5$2.MatSelect, selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex", "hideSingleSelectionIndicator"], exportAs: ["matSelect"] }, { kind: "component", type: i6.MatOption, selector: "mat-option", exportAs: ["matOption"] }, { kind: "component", type: i6.MatOptgroup, selector: "mat-optgroup", inputs: ["disabled"], exportAs: ["matOptgroup"] }, { kind: "component", type: i1$1.DynamicFormElementComponent, selector: "dynamic-form-element" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormSelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-select', template: "<mat-form-field *ngIf=\"!input.multiple; else multiSelect\" appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <mat-select [id]=\"inputId\" [placeholder]=\"input.placeholder\" [required]=\"validation?.required\" [formControl]=\"control\">\n    <ng-container *ngFor=\"let option of input.options\">\n      <ng-container *ngIf=\"!option.items; else optionGroup\">\n        <mat-option [value]=\"option.value\" [disabled]=\"option.disabled\">{{ option.label }}</mat-option>\n      </ng-container>\n      <ng-template #optionGroup>\n        <mat-optgroup [label]=\"option.label\" [disabled]=\"option.disabled\">\n          <ng-container *ngFor=\"let optionItem of option.items\">\n            <mat-option [value]=\"optionItem.value\" [disabled]=\"optionItem.disabled\">{{ optionItem.label }}</mat-option>\n          </ng-container>\n        </mat-optgroup>\n      </ng-template>\n    </ng-container>\n  </mat-select>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matTextPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matTextSuffix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matSuffix\n  ></dynamic-form-element>\n  <mat-hint [align]=\"'start'\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint [align]=\"'end'\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n<ng-template #multiSelect>\n  <mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n    <mat-label>{{ template.label }}</mat-label>\n    <mat-select [id]=\"inputId\" [placeholder]=\"input.placeholder\" [required]=\"validation?.required\" [formControl]=\"control\" multiple>\n      <ng-container *ngFor=\"let option of input.options\">\n        <ng-container *ngIf=\"!option.items; else optionGroup\">\n          <mat-option [value]=\"option.value\" [disabled]=\"option.disabled\">{{ option.label }}</mat-option>\n        </ng-container>\n        <ng-template #optionGroup>\n          <mat-optgroup [label]=\"option.label\" [disabled]=\"option.disabled\">\n            <ng-container *ngFor=\"let optionItem of option.items\">\n              <mat-option [value]=\"optionItem.value\" [disabled]=\"optionItem.disabled\">{{ optionItem.label }}</mat-option>\n            </ng-container>\n          </mat-optgroup>\n        </ng-template>\n      </ng-container>\n    </mat-select>\n    <dynamic-form-element\n      *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n      [element]=\"prefixAddOn\"\n      matTextPrefix\n    ></dynamic-form-element>\n    <dynamic-form-element\n      *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n      [element]=\"prefixAddOn\"\n      matPrefix\n    ></dynamic-form-element>\n    <dynamic-form-element\n      *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n      [element]=\"suffixAddOn\"\n      matTextSuffix\n    ></dynamic-form-element>\n    <dynamic-form-element\n      *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n      [element]=\"suffixAddOn\"\n      matSuffix\n    ></dynamic-form-element>\n    <mat-hint [align]=\"'start'\">{{ hints?.hintStart }}</mat-hint>\n    <mat-hint [align]=\"'end'\">{{ hints?.hintEnd }}</mat-hint>\n    <mat-error>{{ errorMessage }}</mat-error>\n  </mat-form-field>\n</ng-template>\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.DynamicFormValidationService }]; } });

const matDynamicFormSelectType = {
    type: 'select',
    component: MatDynamicFormSelectComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormSelectModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormSelectModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormSelectModule, declarations: [MatDynamicFormSelectComponent], imports: [CommonModule,
            ReactiveFormsModule,
            MatFormFieldModule,
            MatSelectModule,
            DynamicFormElementModule, i1$1.DynamicFormConfigModule], exports: [DynamicFormConfigModule,
            MatDynamicFormSelectComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormSelectModule, imports: [CommonModule,
            ReactiveFormsModule,
            MatFormFieldModule,
            MatSelectModule,
            DynamicFormElementModule,
            DynamicFormConfigModule.withInput(matDynamicFormSelectType), DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormSelectModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        MatFormFieldModule,
                        MatSelectModule,
                        DynamicFormElementModule,
                        DynamicFormConfigModule.withInput(matDynamicFormSelectType),
                    ],
                    declarations: [
                        MatDynamicFormSelectComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormSelectComponent,
                    ],
                }]
        }] });

class MatDynamicFormSwitchComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormSwitchComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormSwitchComponent, selector: "mat-dynamic-form-switch", usesInheritance: true, ngImport: i0, template: "<mat-dynamic-form-input-wrapper [invalid]=\"showErrors\" [errorMessage]=\"showErrors ? errorMessage : null\">\n  <mat-slide-toggle [id]=\"inputId\" color=\"primary\" [required]=\"validation?.required\" [disabled]=\"control.disabled\" [formControl]=\"control\"\n    >{{ template.label }}<span *ngIf=\"validation?.required\">*</span></mat-slide-toggle\n  >\n</mat-dynamic-form-input-wrapper>\n", dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i3$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: i4$5.MatSlideToggleRequiredValidator, selector: "mat-slide-toggle[required][formControlName],             mat-slide-toggle[required][formControl], mat-slide-toggle[required][ngModel]" }, { kind: "component", type: i4$5.MatSlideToggle, selector: "mat-slide-toggle", inputs: ["disabled", "disableRipple", "color", "tabIndex"], exportAs: ["matSlideToggle"] }, { kind: "component", type: MatDynamicFormInputWrapperComponent, selector: "mat-dynamic-form-input-wrapper", inputs: ["label", "required", "invalid", "errorMessage"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormSwitchComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-switch', template: "<mat-dynamic-form-input-wrapper [invalid]=\"showErrors\" [errorMessage]=\"showErrors ? errorMessage : null\">\n  <mat-slide-toggle [id]=\"inputId\" color=\"primary\" [required]=\"validation?.required\" [disabled]=\"control.disabled\" [formControl]=\"control\"\n    >{{ template.label }}<span *ngIf=\"validation?.required\">*</span></mat-slide-toggle\n  >\n</mat-dynamic-form-input-wrapper>\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.DynamicFormValidationService }]; } });

const matDynamicFormSwitchType = {
    type: 'switch',
    component: MatDynamicFormSwitchComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormSwitchModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormSwitchModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormSwitchModule, declarations: [MatDynamicFormSwitchComponent], imports: [CommonModule,
            ReactiveFormsModule,
            MatSlideToggleModule,
            MatDynamicFormInputWrapperModule, i1$1.DynamicFormConfigModule], exports: [DynamicFormConfigModule,
            MatDynamicFormSwitchComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormSwitchModule, imports: [CommonModule,
            ReactiveFormsModule,
            MatSlideToggleModule,
            MatDynamicFormInputWrapperModule,
            DynamicFormConfigModule.withInput(matDynamicFormSwitchType), DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormSwitchModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        MatSlideToggleModule,
                        MatDynamicFormInputWrapperModule,
                        DynamicFormConfigModule.withInput(matDynamicFormSwitchType),
                    ],
                    declarations: [
                        MatDynamicFormSwitchComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormSwitchComponent,
                    ],
                }]
        }] });

class MatDynamicFormTextareaComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTextareaComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormTextareaComponent, selector: "mat-dynamic-form-textarea", usesInheritance: true, ngImport: i0, template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <textarea\n    matInput\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n    cdkTextareaAutosize\n    #autosize=\"cdkTextareaAutosize\"\n    cdkAutosizeMinRows=\"1\"\n  >\n  </textarea>\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matTextPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matTextSuffix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matSuffix\n  ></dynamic-form-element>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n", dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i3$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: i4$3.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4$3.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4$3.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i4$3.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i4$3.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i4$3.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "directive", type: i5$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "directive", type: i6$2.CdkTextareaAutosize, selector: "textarea[cdkTextareaAutosize]", inputs: ["cdkAutosizeMinRows", "cdkAutosizeMaxRows", "cdkTextareaAutosize", "placeholder"], exportAs: ["cdkTextareaAutosize"] }, { kind: "component", type: i1$1.DynamicFormElementComponent, selector: "dynamic-form-element" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTextareaComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-textarea', template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <textarea\n    matInput\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n    cdkTextareaAutosize\n    #autosize=\"cdkTextareaAutosize\"\n    cdkAutosizeMinRows=\"1\"\n  >\n  </textarea>\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matTextPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matTextSuffix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matSuffix\n  ></dynamic-form-element>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.DynamicFormValidationService }]; } });

const matDynamicFormTextareaType = {
    type: 'textarea',
    component: MatDynamicFormTextareaComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormTextareaModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTextareaModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTextareaModule, declarations: [MatDynamicFormTextareaComponent], imports: [CommonModule,
            ReactiveFormsModule,
            MatFormFieldModule,
            MatInputModule,
            DynamicFormElementModule, i1$1.DynamicFormConfigModule], exports: [DynamicFormConfigModule,
            MatDynamicFormTextareaComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTextareaModule, imports: [CommonModule,
            ReactiveFormsModule,
            MatFormFieldModule,
            MatInputModule,
            DynamicFormElementModule,
            DynamicFormConfigModule.withInput(matDynamicFormTextareaType), DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTextareaModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        MatFormFieldModule,
                        MatInputModule,
                        DynamicFormElementModule,
                        DynamicFormConfigModule.withInput(matDynamicFormTextareaType),
                    ],
                    declarations: [
                        MatDynamicFormTextareaComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormTextareaComponent,
                    ],
                }]
        }] });

class MatDynamicFormTextboxComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTextboxComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormTextboxComponent, selector: "mat-dynamic-form-textbox", usesInheritance: true, ngImport: i0, template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    [id]=\"inputId\"\n    [type]=\"input.inputTypeForced || input.inputType\"\n    [placeholder]=\"input.placeholder\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matTextPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matTextSuffix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matSuffix\n  ></dynamic-form-element>\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n", dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i3$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: i4$3.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4$3.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4$3.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i4$3.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i4$3.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i4$3.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "directive", type: i5$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i1$1.DynamicFormElementComponent, selector: "dynamic-form-element" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTextboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-textbox', template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    [id]=\"inputId\"\n    [type]=\"input.inputTypeForced || input.inputType\"\n    [placeholder]=\"input.placeholder\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn?.classType === 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matTextPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"prefixAddOn && prefixAddOn.classType !== 'element' && !prefixAddOn.hidden\"\n    [element]=\"prefixAddOn\"\n    matPrefix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn?.classType === 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matTextSuffix\n  ></dynamic-form-element>\n  <dynamic-form-element\n    *ngIf=\"suffixAddOn && suffixAddOn.classType !== 'element' && !suffixAddOn.hidden\"\n    [element]=\"suffixAddOn\"\n    matSuffix\n  ></dynamic-form-element>\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.DynamicFormValidationService }]; } });

const matDynamicFormTextboxType = {
    type: 'textbox',
    component: MatDynamicFormTextboxComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormTextboxModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTextboxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTextboxModule, declarations: [MatDynamicFormTextboxComponent], imports: [CommonModule,
            ReactiveFormsModule,
            MatFormFieldModule,
            MatInputModule,
            DynamicFormElementModule,
            DynamicFormTextboxModule, i1$1.DynamicFormConfigModule], exports: [DynamicFormConfigModule,
            MatDynamicFormTextboxComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTextboxModule, imports: [CommonModule,
            ReactiveFormsModule,
            MatFormFieldModule,
            MatInputModule,
            DynamicFormElementModule,
            DynamicFormTextboxModule,
            DynamicFormConfigModule.withInput(matDynamicFormTextboxType), DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormTextboxModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        MatFormFieldModule,
                        MatInputModule,
                        DynamicFormElementModule,
                        DynamicFormTextboxModule,
                        DynamicFormConfigModule.withInput(matDynamicFormTextboxType),
                    ],
                    declarations: [
                        MatDynamicFormTextboxComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormTextboxComponent,
                    ],
                }]
        }] });

class MatDynamicFormToggleComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormToggleComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.0-next.7", type: MatDynamicFormToggleComponent, selector: "mat-dynamic-form-toggle", usesInheritance: true, ngImport: i0, template: "<mat-dynamic-form-input-wrapper\n  [label]=\"template.label\"\n  [required]=\"validation?.required\"\n  [invalid]=\"showErrors\"\n  [errorMessage]=\"showErrors ? errorMessage : null\"\n>\n  <mat-button-toggle-group [formControl]=\"control\">\n    <ng-container *ngFor=\"let option of input.options; let i = index\">\n      <mat-button-toggle [id]=\"inputId + '-' + i\" [value]=\"option.value\" [disabled]=\"option.disabled\">{{ option.label }}</mat-button-toggle>\n    </ng-container>\n  </mat-button-toggle-group>\n</mat-dynamic-form-input-wrapper>\n", dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i3$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: i4$6.MatButtonToggleGroup, selector: "mat-button-toggle-group", inputs: ["appearance", "name", "vertical", "value", "multiple", "disabled"], outputs: ["valueChange", "change"], exportAs: ["matButtonToggleGroup"] }, { kind: "component", type: i4$6.MatButtonToggle, selector: "mat-button-toggle", inputs: ["disableRipple", "aria-label", "aria-labelledby", "id", "name", "value", "tabIndex", "appearance", "checked", "disabled"], outputs: ["change"], exportAs: ["matButtonToggle"] }, { kind: "component", type: MatDynamicFormInputWrapperComponent, selector: "mat-dynamic-form-input-wrapper", inputs: ["label", "required", "invalid", "errorMessage"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormToggleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-dynamic-form-toggle', template: "<mat-dynamic-form-input-wrapper\n  [label]=\"template.label\"\n  [required]=\"validation?.required\"\n  [invalid]=\"showErrors\"\n  [errorMessage]=\"showErrors ? errorMessage : null\"\n>\n  <mat-button-toggle-group [formControl]=\"control\">\n    <ng-container *ngFor=\"let option of input.options; let i = index\">\n      <mat-button-toggle [id]=\"inputId + '-' + i\" [value]=\"option.value\" [disabled]=\"option.disabled\">{{ option.label }}</mat-button-toggle>\n    </ng-container>\n  </mat-button-toggle-group>\n</mat-dynamic-form-input-wrapper>\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.DynamicFormValidationService }]; } });

const matDynamicFormToggleType = {
    type: 'toggle',
    component: MatDynamicFormToggleComponent,
    libraryName: matDynamicFormLibrary.name,
};
class MatDynamicFormToggleModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormToggleModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormToggleModule, declarations: [MatDynamicFormToggleComponent], imports: [CommonModule,
            ReactiveFormsModule,
            MatButtonToggleModule,
            MatDynamicFormInputWrapperModule, i1$1.DynamicFormConfigModule], exports: [DynamicFormConfigModule,
            MatDynamicFormToggleComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormToggleModule, imports: [CommonModule,
            ReactiveFormsModule,
            MatButtonToggleModule,
            MatDynamicFormInputWrapperModule,
            DynamicFormConfigModule.withInput(matDynamicFormToggleType), DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormToggleModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        MatButtonToggleModule,
                        MatDynamicFormInputWrapperModule,
                        DynamicFormConfigModule.withInput(matDynamicFormToggleType),
                    ],
                    declarations: [
                        MatDynamicFormToggleComponent,
                    ],
                    exports: [
                        DynamicFormConfigModule,
                        MatDynamicFormToggleComponent,
                    ],
                }]
        }] });

class MatDynamicFormInputModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormInputModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormInputModule, imports: [MatFormFieldModule,
            MatDynamicFormCheckboxModule,
            MatDynamicFormComboboxModule,
            MatDynamicFormDatepickerModule,
            MatDynamicFormFileModule,
            MatDynamicFormNumberboxModule,
            MatDynamicFormRadioModule,
            MatDynamicFormSelectModule,
            MatDynamicFormSwitchModule,
            MatDynamicFormTextareaModule,
            MatDynamicFormTextboxModule,
            MatDynamicFormToggleModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormInputModule, providers: [
            {
                provide: MAT_FORM_FIELD_DEFAULT_OPTIONS,
                useValue: { floatLabel: 'always' },
            },
        ], imports: [MatFormFieldModule,
            MatDynamicFormCheckboxModule,
            MatDynamicFormComboboxModule,
            MatDynamicFormDatepickerModule,
            MatDynamicFormFileModule,
            MatDynamicFormNumberboxModule,
            MatDynamicFormRadioModule,
            MatDynamicFormSelectModule,
            MatDynamicFormSwitchModule,
            MatDynamicFormTextareaModule,
            MatDynamicFormTextboxModule,
            MatDynamicFormToggleModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormInputModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        MatFormFieldModule,
                        MatDynamicFormCheckboxModule,
                        MatDynamicFormComboboxModule,
                        MatDynamicFormDatepickerModule,
                        MatDynamicFormFileModule,
                        MatDynamicFormNumberboxModule,
                        MatDynamicFormRadioModule,
                        MatDynamicFormSelectModule,
                        MatDynamicFormSwitchModule,
                        MatDynamicFormTextareaModule,
                        MatDynamicFormTextboxModule,
                        MatDynamicFormToggleModule,
                    ],
                    providers: [
                        {
                            provide: MAT_FORM_FIELD_DEFAULT_OPTIONS,
                            useValue: { floatLabel: 'always' },
                        },
                    ],
                }]
        }] });

class MatDynamicFormsModule {
    static forRoot(config) {
        return {
            ngModule: MatDynamicFormsModule,
            providers: [
                {
                    provide: DYNAMIC_FORM_LIBRARY,
                    useValue: matDynamicFormLibrary,
                },
                {
                    provide: DYNAMIC_FORM_THEME,
                    useValue: config && config.theme,
                },
                {
                    provide: DYNAMIC_FORM_ID_BUILDER,
                    useValue: config && config.idBuilder,
                },
            ],
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormsModule, imports: [CommonModule,
            ReactiveFormsModule,
            DynamicFormsModule,
            DynamicFormControlModule,
            DynamicFormGroupModule,
            DynamicFormArrayModule,
            DynamicFormDictionaryModule, i1$1.DynamicFormValidationModule, DynamicFormContainerModule,
            DynamicFormContentModule,
            DynamicFormTextModule,
            MatDynamicFormElementModule,
            MatDynamicFormActionModule,
            MatDynamicFormInputModule], exports: [DynamicFormsModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormsModule, imports: [CommonModule,
            ReactiveFormsModule,
            DynamicFormsModule,
            DynamicFormControlModule,
            DynamicFormGroupModule,
            DynamicFormArrayModule,
            DynamicFormDictionaryModule,
            DynamicFormValidationModule.withValidation(),
            DynamicFormContainerModule,
            DynamicFormContentModule,
            DynamicFormTextModule,
            MatDynamicFormElementModule,
            MatDynamicFormActionModule,
            MatDynamicFormInputModule, DynamicFormsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.0-next.7", ngImport: i0, type: MatDynamicFormsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        DynamicFormsModule,
                        DynamicFormControlModule,
                        DynamicFormGroupModule,
                        DynamicFormArrayModule,
                        DynamicFormDictionaryModule,
                        DynamicFormValidationModule.withValidation(),
                        DynamicFormContainerModule,
                        DynamicFormContentModule,
                        DynamicFormTextModule,
                        MatDynamicFormElementModule,
                        MatDynamicFormActionModule,
                        MatDynamicFormInputModule,
                    ],
                    exports: [
                        DynamicFormsModule,
                    ],
                }]
        }] });

/*
 * Public API Surface of material
 */

/**
 * Generated bundle index. Do not edit.
 */

export { MatDynamicFormAccordionComponent, MatDynamicFormAccordionModule, MatDynamicFormActionModule, MatDynamicFormButtonComponent, MatDynamicFormButtonModule, MatDynamicFormCheckboxComponent, MatDynamicFormCheckboxModule, MatDynamicFormComboboxComponent, MatDynamicFormComboboxModule, MatDynamicFormDatepickerComponent, MatDynamicFormDatepickerModule, MatDynamicFormDialogComponent, MatDynamicFormDialogModule, MatDynamicFormElementModule, MatDynamicFormFileComponent, MatDynamicFormFileModule, MatDynamicFormInputModule, MatDynamicFormItemsModule, MatDynamicFormModalComponent, MatDynamicFormModalModule, MatDynamicFormNumberboxComponent, MatDynamicFormNumberboxModule, MatDynamicFormRadioComponent, MatDynamicFormRadioModule, MatDynamicFormSelectComponent, MatDynamicFormSelectModule, MatDynamicFormTabsComponent, MatDynamicFormTabsModule, MatDynamicFormTextareaComponent, MatDynamicFormTextareaModule, MatDynamicFormTextboxComponent, MatDynamicFormTextboxModule, MatDynamicFormsModule, matDynamicFormAccordionType, matDynamicFormButtonType, matDynamicFormCheckboxType, matDynamicFormComboboxType, matDynamicFormDatepickerType, matDynamicFormFileType, matDynamicFormLibrary, matDynamicFormModalType, matDynamicFormNumberboxType, matDynamicFormRadioType, matDynamicFormSelectType, matDynamicFormTabsType, matDynamicFormTextareaType, matDynamicFormTextboxType };
//# sourceMappingURL=dynamic-forms-material.mjs.map
